diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/unittools.c freeciv-patched/server/unittools.c
--- freeciv-cvs/server/unittools.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/server/unittools.c	2003-06-30 12:18:10.000000000 +0100
@@ -70,7 +70,8 @@
 static struct unit *choose_more_important_refuel_target(struct unit *punit1,
 							struct unit *punit2);
 static bool maybe_cancel_patrol_due_to_enemy(struct unit *punit);
-static int hp_gain_coord(struct unit *punit);
+static int hp_gain_coord(struct unit *punit, struct city *pcity,
+			 bool fullrepair);
 
 /**************************************************************************
   returns a unit type with a given role, use -1 if you don't want a tech 
@@ -110,12 +111,19 @@
 **************************************************************************/
 void maybe_make_veteran(struct unit *punit)
 {
+  int amount = 50;   /* Normally there's a 50% chance... */
+
   if (punit->veteran)
     return;
-  if (player_owns_active_wonder(unit_owner(punit), B_SUNTZU))
-    punit->veteran = TRUE;
-  else
-    punit->veteran = (myrand(2) == 1);
+
+  /* Do we have any veteran-making effects? */
+  unit_effects_iterate(iter, punit, punit) {
+    if (iter.imeff->type == EFT_UNIT_VET_COMBAT) {
+      amount = MAX(amount, iter.imeff->amount);
+    }
+  } unit_effects_iterate_end;
+
+  punit->veteran = (myrand(100) < amount ? 1 : 0);
 }
 
 /**************************************************************************
@@ -209,42 +217,67 @@
 }
 
 /***************************************************************************
-Do Leonardo's Workshop upgrade(s). Select unit to upgrade by random. --Zamar
-Now be careful not to strand units at sea with the Workshop. --dwp
+  Possibly upgrade units belonging to the given player (restricted to the
+  given continent or city, if not -1 and NULL respectively) by applying the
+  effect pointed to by "iter"
 ****************************************************************************/
-static void handle_leonardo(struct player *pplayer)
+static void handle_unit_upgrades(struct player *pplayer, int continent,
+				 struct city *pcity, struct eff_iter *iter)
 {
-  int upgrade_type; 
-  int leonardo_variant;
-	
+  enum effect_type eff_type;
+  Impr_Type_id impr;
   struct unit_list candidates;
-  int candidate_to_upgrade=-1;
-
-  int i;
-
-  leonardo_variant = improvement_variant(B_LEONARDO);
-	
+  int upgrade_all, upgrade_leap, i, candidate_to_upgrade = -1;
+  int upgrade_type;
+  struct unit_classes aff_unit;
+  enum tile_special_type spec_t;
+  enum tile_terrain_type tile_t;
+
+  assert(iter != NULL);
+  eff_type = iter->imeff->type;
+  impr = eff_iterator_get_improvement(iter);
+
+  upgrade_all  = (eff_type == EFT_UPGRADE_ALL_STEP
+		  || eff_type == EFT_UPGRADE_ALL_LEAP);
+  upgrade_leap = (eff_type == EFT_UPGRADE_ONE_LEAP
+		  || eff_type == EFT_UPGRADE_ALL_LEAP);
+  
   unit_list_init(&candidates);
 	
   unit_list_iterate(pplayer->units, punit) {
-    if ((upgrade_type=can_upgrade_unittype(pplayer, punit->type))!=-1 &&
-       !upgrade_would_strand(punit, upgrade_type))
+    struct city *mapcity = map_get_city(punit->x, punit->y);
+
+    tile_t = map_get_terrain(punit->x, punit->y);
+    spec_t = map_get_special(punit->x, punit->y);
+    get_unit_classes(punit, &aff_unit);
+
+    if (is_unit_terrain_affected(iter->imeff, &aff_unit, tile_t, spec_t) &&
+	is_effect_outside(iter->imeff, mapcity) &&
+	(continent == -1 ||
+	 continent == map_get_continent(punit->x, punit->y)) &&
+	(!pcity || pcity == mapcity) &&
+	(upgrade_type = can_upgrade_unittype(pplayer, punit->type,
+					   upgrade_leap)) != -1 &&
+	!upgrade_would_strand(punit, upgrade_type)) {
       unit_list_insert(&candidates, punit); /* Potential candidate :) */
+    }
   } unit_list_iterate_end;
-	
+
   if (unit_list_size(&candidates) == 0)
     return; /* We have Leonardo, but nothing to upgrade! */
-	
-  if (leonardo_variant == 0)
+
+  if (!upgrade_all) {
     candidate_to_upgrade=myrand(unit_list_size(&candidates));
+  }
 
-  i=0;	
+  i=0;
   unit_list_iterate(candidates, punit) {
-    if (leonardo_variant != 0 || i == candidate_to_upgrade) {
-      upgrade_type=can_upgrade_unittype(pplayer, punit->type);
+    if ((upgrade_all || i == candidate_to_upgrade) &&
+        myrand(100) < iter->imeff->amount) {
+      upgrade_type = can_upgrade_unittype(pplayer, punit->type, upgrade_leap);
       notify_player(pplayer,
             _("Game: %s has upgraded %s to %s%s."),
-            improvement_types[B_LEONARDO].name,
+            get_improvement_name(impr),
             unit_type(punit)->name,
             get_unit_type(upgrade_type)->name,
             get_location_str_in(pplayer, punit->x, punit->y));
@@ -253,11 +286,72 @@
     }
     i++;
   } unit_list_iterate_end;
-	
+
   unit_list_unlink_all(&candidates);
 }
 
 /***************************************************************************
+Do Leonardo's Workshop upgrade(s). Select unit to upgrade by random. --Zamar
+Now be careful not to strand units at sea with the Workshop. --dwp
+Use any active effects from rulesets. --bmw
+****************************************************************************/
+static void handle_leonardo(struct player *pplayer)
+{
+  struct eff_iter iter;
+  bool *cont_done;
+  bool player_done = FALSE;
+  int this_cont;
+
+  /* Since the effect may be restricted to a city, iterate over all cities
+     to find all such effect instances. Keep track of which Island- and
+     Player- range effects we pick up, though, so that we don't apply them
+     multiple times (these effects are shared by multiple cities) */
+  cont_done = fc_calloc(map.num_continents + 1, sizeof(bool));
+  city_list_iterate(pplayer->cities, pcity) {
+
+    /* Don't mark the player/island as "done" until we've looked at all
+       effects (as multiple effects at each range are possible) */
+    bool this_playerdone = FALSE, this_contdone = FALSE;
+
+    this_cont = map_get_continent(pcity->x, pcity->y);
+    eff_iterator_impr_init(&iter, B_LAST, pcity,
+		      (player_done && cont_done[this_cont]) ? NULL : pplayer);
+    while (eff_iterator_next(&iter)) {
+      switch(iter.imeff->type) {
+        case EFT_UPGRADE_ONE_STEP: case EFT_UPGRADE_ONE_LEAP:
+        case EFT_UPGRADE_ALL_STEP: case EFT_UPGRADE_ALL_LEAP:
+          switch(iter.imeff->range) {
+            case EFR_PLAYER: case EFR_WORLD:
+              if (!player_done) {
+                handle_unit_upgrades(pplayer, -1, NULL, &iter);
+              }
+              this_playerdone = TRUE;
+              break;
+            case EFR_ISLAND:
+              if (!cont_done[this_cont]) {
+                handle_unit_upgrades(pplayer, this_cont, NULL, &iter);
+              }
+              this_contdone = TRUE;
+              break;
+            case EFR_CITY:
+              handle_unit_upgrades(pplayer, -1, pcity, &iter);
+              break;
+            default:
+              break;
+          }
+          break;
+        default:
+          break;
+      }
+    }
+    player_done |= this_playerdone;
+    cont_done[this_cont] |= this_contdone;
+  } city_list_iterate_end;
+
+  free(cont_done);
+}
+
+/***************************************************************************
 Select which unit is more important to refuel:
 It's more important to refuel plane which has less fuel.
 If those are equal then we refuel more valuable unit.
@@ -382,11 +476,13 @@
 void player_restore_units(struct player *pplayer)
 {
   /* 1) get Leonardo out of the way first: */
-  if (player_owns_active_wonder(pplayer, B_LEONARDO))
-    handle_leonardo(pplayer);
+  handle_leonardo(pplayer);
 
   unit_list_iterate(pplayer->units, punit) {
 
+    /* Set relevant hp/move modifiers from generalised improvements */
+    unit_update_modifiers(pplayer, punit);
+
     /* 2) Modify unit hitpoints. Helicopters can even lose them. */
     unit_restore_hitpoints(pplayer, punit);
 
@@ -406,8 +502,7 @@
     }
 
     /* 4) Check that triremes are near coastline, otherwise... */
-    if (unit_flag(punit, F_TRIREME)
-	&& myrand(100) < trireme_loss_pct(pplayer, punit->x, punit->y)) {
+    if (myrand(100) < ship_loss_pct(punit, punit->x, punit->y)) {
       notify_player_ex(pplayer, punit->x, punit->y, E_UNIT_LOST, 
 		       _("Game: Your %s has been lost on the high seas."),
 		       unit_name(punit->type));
@@ -476,6 +571,36 @@
 }
 
 /****************************************************************************
+  Apply hitpoint and move modifiers to the given unit, to save on
+  recalculation every time we update moverate/hitpoints
+*****************************************************************************/
+void unit_update_modifiers(struct player *pplayer, struct unit *punit)
+{
+  bool fullrepair = FALSE;
+  int hp_recover = 0, move_modifier = 0;
+
+  /* Add effects of generalised improvements */
+  unit_effects_iterate(iter, punit, punit) {
+    switch(iter.imeff->type) {
+    case EFT_UNIT_REPAIR:
+      fullrepair = TRUE;
+      break;
+    case EFT_UNIT_RECOVER:
+      hp_recover += iter.imeff->amount;
+      break;
+    case EFT_UNIT_MOVE:
+      move_modifier += iter.imeff->amount;
+      break;
+    default:
+      break;
+    }
+  } unit_effects_iterate_end;
+
+  punit->hp_recover = (fullrepair ? -1 : hp_recover);
+  punit->move_modifier = move_modifier * SINGLE_MOVE;
+}
+
+/****************************************************************************
   add hitpoints to the unit, hp_gain_coord returns the amount to add
   united nations will speed up the process by 2 hp's / turn, means helicopters
   will actually not loose hp's every turn if player have that wonder.
@@ -485,18 +610,19 @@
 static void unit_restore_hitpoints(struct player *pplayer, struct unit *punit)
 {
   bool was_lower;
+  struct city *pcity = map_get_city(punit->x, punit->y);
+  bool fullrepair = (punit->hp_recover == -1);
 
   was_lower=(punit->hp < unit_type(punit)->hp);
 
   if(!punit->moved) {
-    punit->hp+=hp_gain_coord(punit);
+    punit->hp += hp_gain_coord(punit, pcity, fullrepair);
   }
   
-  if (player_owns_active_wonder(pplayer, B_UNITED)) 
-    punit->hp+=2;
-    
+  /* hp_recover is set by unit_update_modifiers */
+  if (!fullrepair) punit->hp += punit->hp_recover;
+
   if(is_heli_unit(punit)) {
-    struct city *pcity = map_get_city(punit->x,punit->y);
     if(!pcity) {
       if (!map_has_special(punit->x, punit->y, S_AIRBASE))
         punit->hp-=unit_type(punit)->hp/10;
@@ -542,27 +668,19 @@
   ports    will regen navalunits completely
   fortify will add a little extra.
 ***************************************************************************/
-static int hp_gain_coord(struct unit *punit)
+static int hp_gain_coord(struct unit *punit, struct city *pcity,
+			 bool fullrepair)
 {
   int hp;
-  struct city *pcity;
   if (unit_on_fortress(punit))
     hp=unit_type(punit)->hp/4;
   else
     hp=0;
-  if((pcity=map_get_city(punit->x,punit->y))) {
-    if ((city_got_barracks(pcity) &&
-	 (is_ground_unit(punit) || improvement_variant(B_BARRACKS)==1)) ||
-	(city_got_building(pcity, B_AIRPORT) && is_air_unit(punit)) || 
-	(city_got_building(pcity, B_AIRPORT) && is_heli_unit(punit)) || 
-	(city_got_building(pcity, B_PORT) && is_sailing_unit(punit))) {
-      hp=unit_type(punit)->hp;
-    }
-    else
-      hp=unit_type(punit)->hp/3;
-  }
-  else if (!is_heli_unit(punit))
+  if (pcity) {
+    hp = fullrepair ? unit_type(punit)->hp : unit_type(punit)->hp / 3;
+  } else if (!is_heli_unit(punit)) {
     hp++;
+  }
 
   if(punit->activity==ACTIVITY_FORTIFIED)
     hp++;
@@ -1457,9 +1575,14 @@
     punit->hp = hp_left;
   }
 
+  /* Apply/remove effects of Magellan etc. */
+  unit_update_modifiers(pplayer, punit);
+
   if (moves_left >= 0) {
     /* Override default full MP */
     punit->moves_left = moves_left;
+  } else {
+    punit->moves_left = unit_move_rate(punit);
   }
 
   /* Assume that if moves_left < 0 then the unit is "fresh",
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/unittools.h freeciv-patched/server/unittools.h
--- freeciv-cvs/server/unittools.h	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/server/unittools.h	2003-06-30 12:16:19.000000000 +0100
@@ -35,6 +35,7 @@
 void update_unit_activities(struct player *pplayer);
 
 /* various */
+void unit_update_modifiers(struct player *pplayer, struct unit *punit);
 char *get_location_str_in(struct player *pplayer, int x, int y);
 char *get_location_str_at(struct player *pplayer, int x, int y);
 enum goto_move_restriction get_activity_move_restriction(enum unit_activity activity);
